FFITests
 subclass: #NodeFFITests
 instanceVariableNames: ''
 classVariableNames: ' '
 poolDictionaries: ''
 category: 'NodeFFITests'!
NodeFFITests comment: '
	Tests for API calls defined in NodeJS executable.
	Note: This is a test of FFI functionality to expose bindings to running executable.
	In this case it is expected to be running S8+FFI on top of NodeJS runtime engine.
'!
NodeFFITests class instanceVariableNames: ' library '!

! NodeFFITests class methodsFor: 'accessing' !
library
	" Private - Return the library of the receiver. "

	library isNil ifTrue: [ library := self newDynamicLibrary: self libraryFileName ].
	^library! !

! NodeFFITests class methodsFor: 'accessing' !
libraryFileName
	" Private - Return the library fileName. "

	^nil "we bind to running executable"! !

! NodeFFITests class methodsFor: 'tests' !
test00
	" Inform all is ok, loaded and ready to run tests. "

	self library isNil ifTrue: [ ^'Failed to bind to running executable.' ].
	^#Ok ,' - Running ',self name! !

! NodeFFITests class methodsFor: 'tests' !
test01
	" Inspect the library. "

"DEBUG-
	self inspect: self library as: 'running executable'.
"	^#Ok! !

! NodeFFITests class methodsFor: 'tests' !
test02
	" Test access and evaluation of internal function implemented by running executable. "

	| api mangled p size result |
	size := 1024.
	p := self newPointer: size.
	mangled := #uv_cwd.
	api := self library #get: mangled.
	api := self cdecl: api return: #ulong types: #( #pointer #size_t ). "uv_err_t uv_cwd(char* buffer, size_t size)"
	result := # #api: p size: size.
	^#Ok ,' - ' ,mangled ,'=' ,p getCString ,' result=' ,result! !

! NodeFFITests class methodsFor: 'tests' !
test03

	| api mangled |
	mangled := #uv_get_free_memory.
	api := self library #get: mangled.
	api := self cdecl: api return: #int64 types: #().
	^#Ok ,' - ' ,mangled ,'=' ,# #api! !

! NodeFFITests class methodsFor: 'tests' !
test04

	| api mangled |
	mangled := #uv_get_total_memory.
	api := self library #get: mangled.
	api := self cdecl: api return: #int64 types: #().
	^#Ok ,' - ' ,mangled ,'=' ,# #api! !

