FFITests
 subclass: #NodeJSTests
 instanceVariableNames: ''
 classVariableNames: ' '
 poolDictionaries: ''
 category: 'NodeJSTests'!
NodeJSTests comment: '
	Tests of NodeJS features.
'!


! NodeJSTests class methodsFor: 'utilities' !
http
	" Private - Return the FFI module. "

	^# #require: #http! !

! NodeJSTests class methodsFor: 'utilities' !
withOptions: options do: dataBlock
	" Private - Evaluates the dataBlock with data obtained accessing server options. "

	| request http |
	http := self http.
	request := http #request: options doing: [:response|
self print: 'Got response:' ,response#statusCode.
		response
			#setEncoding: #utf8;
			#on: #data do: [:chunk| dataBlock value: chunk ]
	].
	request #on: #error do: [:ex| self error: 'Got error: ', ex#message ].
	request #write: 'data\n'; #write: 'data\n'; end.
	^nil! !

! NodeJSTests class methodsFor: 'utilities' !
withSwiki: swikiName page: pageNumber do: dataBlock
	" Private - Evaluates the dataBlock with data obtained from swikipage. "

	^self withOptions: (self json: (Array
		with: (Array with: #host with: 'aleReimondo.no-ip.org')
		with: (Array with: #port with: 80)
		with: (Array with: #path with: swikiName,'/',pageNumber)
		)) do: dataBlock! !

! NodeJSTests class methodsFor: 'tests' !
test01
	" Try to access ale's swiki for testing. "

	self print: 'Accessing swiki page...'.
	self withSwiki: 's8-tests' page: '.pages' do: [:data|
		self print: 'data=', data
	]
	^#Ok! !